import javax.swing.SwingUtilities;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.BorderFactory;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import java.awt.geom.Line2D;
import java.util.Arrays;

public class Plotter {


    public static void plot(ValuesToDraw valuesToDraw) {


        SwingUtilities.invokeLater(new Runnable() {

            public void run() {
                createAndShowGUI(valuesToDraw);
            }

        });
    }



    public static void createAndShowGUI(ValuesToDraw valuesToDraw) {

        JFrame f = new JFrame("Function Plotter");
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.add(new PlotterPanel(valuesToDraw));
        f.pack();
        f.setVisible(true);

    }
}

class PlotterPanel extends JPanel {


    int[] test = new int[]{-20, -19, -18, -17, -16, -15, -14, -13, -12, -11, -10,
            -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
            10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20};
    int[] test2 = new int[]{-20, -19, -18, -17, -16, -15, -14, -13, -12, -11, -10,
            -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
            10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20};





    final int ZERO_POINT_X = 300;
    final int ZERO_POINT_Y = 400;

    ValuesToDraw valuesToDraw;



    PlotterPanel(ValuesToDraw valuesToDraw) {
        this.valuesToDraw = valuesToDraw;


        addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                System.out.println("maus gedrückt");


                int[] xCordsWithOffset = new int[41];
                int[] yCordsWithOffset = new int[41];


                int i = 0;

                int[] xCords = valuesToDraw.getXCords();

                for(int cord : xCords) {

                    xCordsWithOffset[i] = (ZERO_POINT_X + (cord * -1 * 10));
                    i++;
                }

                System.out.println(Arrays.toString(xCordsWithOffset));

                int j = 0;

                int[] yCords = valuesToDraw.getYCords();

                for(int cord : yCords) {
                    System.out.print("cords=" + cord);
                    yCordsWithOffset[j] = ZERO_POINT_Y + (cord * 10);
                    j++;
                }

                System.out.println(Arrays.toString(yCordsWithOffset));


                test2 = xCordsWithOffset;
                test = yCordsWithOffset;



                updateUI();
            }
        });

    }




    public Dimension getPreferredSize() {
        return new Dimension(800,600);
    }

    protected void paintComponent(Graphics g) {
        super.paintComponent(g);


        g.drawLine(400, 0, 400, 600);
        g.drawLine(0, 300, 800, 300);


        //x=0, y=20
        g.drawLine(375, 100, 425, 100);
        //x=0, y=-20
        g.drawLine(375, 500, 425, 500);
        //x=-20, y=0
        g.drawLine(200,275 , 200, 325);
        //x=20, y=0
        g.drawLine(600,275 , 600, 325);

        drawPoints(g);


    }


    private void drawPoints(Graphics g){



        Graphics2D g2d = (Graphics2D) g;

        g2d.drawPolyline(test, test2, 41);


    }



}


