import java.io.*;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Scanner;

public class main {

    public static void main(String[] args) throws IOException {



        // values above integer space will produce errors

        ArrayList<String> stringsFromFile = new ArrayList<>();

        String filePath = "./Aufgabe4/expressions.txt";

        Scanner scan = null;
        try {

            scan = new Scanner(new File(filePath));

            while (scan.hasNext()) {

                stringsFromFile.add(scan.nextLine());

            }

            scan.close();

        } catch (FileNotFoundException | NullPointerException e) {
            e.printStackTrace();
        }



        Lexer lexer = new Lexer();

        ArrayList<ArrayList<Token>> tokenListList = new ArrayList<>();


        for(String s : stringsFromFile) {

            tokenListList.add(lexer.lex(s));

        }


        Parser p = new Parser();

        ArrayList<AstExpression> rootAstExpressions = new ArrayList<>();


        for(ArrayList<Token> tokenList : tokenListList) {
            rootAstExpressions.add(p.parse(tokenList));
        }


        Evaluator e = new Evaluator();

        ArrayList<int[]> arraysOfXValues = new ArrayList<>();

        for(AstExpression astExpression : rootAstExpressions) {

            int[] xCords = new int[41];

            int j = 0;

            for(int i = -20; i < 21; i++) {
                e.setCounter(i);

                xCords[j] = (int) e.visit(astExpression);

                System.out.println(e.visit(astExpression));
                j++;
            }

            arraysOfXValues.add(xCords);

            System.out.println("------------");

        }

        ValuesToDraw valuesToDraw = new ValuesToDraw(arraysOfXValues);

        Plotter.plot(valuesToDraw);


    }

    public static void printAst(AstExpression astExpression) {

        if(astExpression.astExpression != null) {
            System.out.print("(");
            printAst(astExpression.astExpression);
            System.out.print( ")");
            return;
        }

        if(astExpression.astValue != null) {

            if(astExpression.astValue.astNumber != null) {

                System.out.print(astExpression.astValue.astNumber.astDigitWoz.astDigitWozContent);

            } else if (astExpression.astValue.astVariable != null) {

                System.out.print(astExpression.astValue.astVariable.astVariable);

            } else {
                System.out.println(astExpression.astValue.astDecimal.astDigitBeforeComma.astDigitWoz.astDigitWozContent
                        + "."
                        + astExpression.astValue.astDecimal.astDigitAfterComma.astDigitWoz.astDigitWozContent);
            }
            return;
        }

        printAst(astExpression.astBinaryOp.astExpression1);
        System.out.print(astExpression.astBinaryOp.astOperator.astOperator);
        printAst(astExpression.astBinaryOp.astExpression2);

    }

}
